/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/


package casa.dodwan.hub;

import java.util.Collection;

public interface Environment {
    
    public void addNode(String id, boolean online);

    public void deleteNode(String id);

    public void setNode(String id, boolean online);

    public void setNodeStatus(String id, String status);

    public void setConnectionStatus(String id1, String id2,
				    boolean connected);
    
    public boolean isNode(String id);

    public boolean isOnline(String id);

    public Collection<String> getNodes();

    public boolean arePeers(String id1, String id2);

    public Collection<String> getPeers(String id);
 
}
 
