/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/



package casa.dodwan.util;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class ConsoleClientHandler extends Thread {

    private Console console_;
    
    private BufferedReader in_;
    
    private PrintStream out_ = null;
    
    private java.net.Socket socket_;
    
    public Verbosity verbosity = new Verbosity();
    
    // ------------------------------------------------------------
    public ConsoleClientHandler(java.net.Socket socket, 
				Console console)
	throws Exception {

	socket_ = socket;
	console_ = console;
	
	out_ = new PrintStream(socket_.getOutputStream());
	in_ = new BufferedReader(new InputStreamReader(socket_.getInputStream()));
    }

    // ------------------------------------------------------------
    @Override
	public void run() {
	
	if (verbosity.isEnabled())
	    System.out.println("ConsoleClientHandler.run(): initiating console session on socket "
			       + socket_);
	
	try {
	    console_.parseCommandStream(in_, out_, false);
	    
	    if (verbosity.isEnabled())
		System.out.println("ConsoleClientHandler.run(): closing console session on socket "
				   + socket_);
	}
	catch (Exception e) {};

	try {
	    socket_.close();
	} catch (Exception e) {}
    }
}
