/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/




package casa.dodwan.util;

import java.io.*;
import java.math.BigInteger;
import java.security.MessageDigest;

public class MD5sum {

    public static String digest(byte[] buffer) 
	throws Exception {
	
	MessageDigest digest = MessageDigest.getInstance("MD5");
	digest.update(buffer, 0, buffer.length);
	byte[] md5sum = digest.digest();
	BigInteger bigInt = new BigInteger(1, md5sum);
	String result = bigInt.toString(16);
	
	return result;
    }

    //------------------------------------------------------------
    public static String digest(String fname) 
	throws Exception {

	MessageDigest digest = MessageDigest.getInstance("MD5");
	File f = new File(fname);
	InputStream is = new FileInputStream(f);				
	byte[] buffer = new byte[8192];
	int read = 0;

	while( (read = is.read(buffer)) > 0) {
	    digest.update(buffer, 0, read);
	}		
	byte[] md5sum = digest.digest();
	BigInteger bigInt = new BigInteger(1, md5sum);
	String result = bigInt.toString(16);
	is.close();

	return result;
    }

    //------------------------------------------------------------
    public static void main(String[] args) 
	throws Exception {

	if (args.length == 0) {
	    System.out.println("MD5sum {file}+");
	    System.exit(0);
	}

	for (int i=0; i<args.length; i++)
	    System.out.println(digest(args[i]) + "  " + args[i]);
    }		
}
