/* *****************************************************************************
 * Copyright (c) IRISA Laboratory, 
 * Universite Bretagne Sud, France
 * <http://www-casa.irisa.fr/dodwan>
 *
 * This file is part of DoDWAN.
 * 
 * DoDWAN is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software 
 * Foundation, either version 3 of the License, or any later
 * version.
 * 
 * DoDWAN is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * DoDWAN.  If not, see <http://www.gnu.org/licenses/>.
 * ****************************************************************************/



package casa.dodwan.util;

public class SuspendableSink<DOCTYPE> extends Suspendable implements
		Sink<DOCTYPE> {

	private Sink<DOCTYPE> sink_;

	public Verbosity verbosity = new Verbosity();

	// ------------------------------------------------------------
	public SuspendableSink(Sink<DOCTYPE> sink, boolean isSuspended)
			throws Exception {

		sink_ = sink;
		isSuspended_ = isSuspended;
	}

	// ------------------------------------------------------------
	public void setSink(Sink<DOCTYPE> sink) {

		sink_ = sink;
	}

	// ------------------------------------------------------------
	@Override
	public String toString() {
		return "SuspendableSink(isSuspended=" + isSuspended_ + ", sink="
				+ sink_ + ")";
	}

	// ------------------------------------------------------------
	public void write(DOCTYPE value) throws Exception {

		// if (value instanceof TransferDocument) {
		// TransferDocument doc = (TransferDocument)value;
		// long now = System.currentTimeMillis();
		// String str = doc.getAttribute("_inceptDate");
		// if (str != null) {
		// long inceptDate = Long.parseLong(str);
		// System.out.println(" Document received after "
		// + (now - inceptDate)
		// + " ms");
		// }
		// else
		// doc.setAttribute("_inceptDate", String.valueOf(now));

		if (verbosity.isEnabled()) {
			System.out.println("SuspendableSink.write(): " + value);
			if (isSuspended_)
				System.out
						.println("  Discarding this document: sink is suspended...");
		}

		if (!isSuspended_)
			sink_.write(value);
	}

}
